#!/bin/sh
SSD_VERSION=0754.00
CURR_SSD_VERSION=0754.00

PCKG_INST_PATH="/Library/Receipts/SentinelSystemDriver.pkg"
SDK_PCKG_PATH="/Library/Receipts/SentinelKeysSDK.pkg"
LICMGR_PCKG_PATH="/Library/Receipts/SentinelKeysLicenseManager.pkg"
SKPI_PCKG_PATH="/Library/Receipts/SentinelKeysProtectionInstaller.pkg"
SNTL_COMM_PATH="/Applications/Safenet Sentinel"
SUPRO_PCKG_PATH=/Library/Receipts/SentinelSuperPro*
FRMWRK_INST_PATH="/Library/Frameworks/Sentinel.framework"

UPRO_PCKG_PATH="/Library/Receipts/SentinelUltraPro(English).pkg"
UPRO_SPI_PATH="/Library/Receipts/SentinelProtectionInstaller.pkg"
UPRO_FRMWRK_PATH="/Library/Receipts/SentinelFramework.pkg"
UPRO_KM_PATH="/Library/Receipts/SentinelKeyManager(English).pkg"

ISDRIVER=0

dash_ln="----------------------------------------------------------------------"

echo $dash_ln
echo "              Sentinel System Driver version 7.5.4 Un-installation Script"
echo "                   Copyright (C) 2014 SafeNet, Inc."
echo "                         All rights reserved."
echo $dash_ln
echo

echo "This script will uninstall the Sentinel System Driver.";echo

### Check whether Sentinel System Driver package is installed 
   [ -d /Library/Extensions/Sentinel.kext ]
   if [ $? -ne 0 ]
   then
      echo "Sentinel System Driver package not installed.";echo
      exit
   fi

### Check if the current user has administrative rights
   id | grep "admin" > /dev/null 2>&1
   if [ $? -ne 0 ]
   then 
       echo "To uninstall this package you should have root permission."
       echo "Uninstallation aborted."
       echo 
       exit
   fi
  
### Check if some other application is also using this package.
    
[ -f "/Library/Receipts/SafenetSentinelProduct.Info" ]
if [ $? -eq 0 ]
then
    sudo chmod 777 /Library/Receipts/SafenetSentinelProduct.Info
	grep SentinelSystemDriver /Library/Receipts/SafenetSentinelProduct.Info > /dev/null 2>&1
	if [ $? = 0 ]
	then
    ssd_version=`grep SentinelSystemDriver /Library/Receipts/SafenetSentinelProduct.Info | cut -d = -f 2 | cut -d : -f 1`
	   if [ $ssd_version = $CURR_SSD_VERSION ]
    then
       current_inst=`grep SentinelSystemDriver /Library/Receipts/SafenetSentinelProduct.Info | cut -d = -f 3`
       if [ $current_inst -gt 1 ]
       then  
          echo "Unable to uninstall the Sentinel System Driver due to other users/applications dependency!!"      
          decrement_inst=1
          count_SSD=`expr $current_inst - $decrement_inst`
          sudo echo "/SentinelSystemDriver/" > /tmp/SNTLCMD
          sudo echo "d" >> /tmp/SNTLCMD; echo "w" >> /tmp/SNTLCMD; echo "q" >> /tmp/SNTLCMD
          (sudo grep "SentinelSystemDriver" /Library/Receipts/SafenetSentinelProduct.Info && sudo ed /Library/Receipts/SafenetSentinelProduct.Info < /tmp/SNTLCMD) > /dev/null 2>&1 
          echo "SentinelSystemDriver="$SSD_VERSION":Count="$count_SSD  >>  /Library/Receipts/SafenetSentinelProduct.Info
          rm -rf /tmp/SNTLCMD
          exit
       fi 
      
       if [ $current_inst = 1 ]
       then  
          decrement_inst=1
          count_SSD=`expr $current_inst - $decrement_inst`
          sudo echo "/SentinelSystemDriver/" > /tmp/SNTLCMD
          sudo echo "d" >> /tmp/SNTLCMD; echo "w" >> /tmp/SNTLCMD; echo "q" >> /tmp/SNTLCMD
          (sudo grep "SentinelSystemDriver" /Library/Receipts/SafenetSentinelProduct.Info && sudo ed /Library/Receipts/SafenetSentinelProduct.Info < /tmp/SNTLCMD) > /dev/null 2>&1
          #echo "SentinelSystemDriver="$SSD_VERSION":Count="$count_SSD  >>  /Library/Receipts/SafenetSentinelProduct.Info
          sed  "/^SentinelSystemDriver="$SSD_VERSION":Count="$count_SSD"/d" /Library/Receipts/SafenetSentinelProduct.Info > /tmp/SNTLCMD
          sudo cp /tmp/SNTLCMD /Library/Receipts/SafenetSentinelProduct.Info  
          rm -rf /tmp/SNTLCMD

          ### Remove Package entry
    	  sudo rm -rf "/Library/Receipts/SentinelSystemDriver.pkg" > /dev/null 2>&1
          if [ $? -ne 0 ]
          then
             echo "Error occured while uninstalling Sentinel System Driver package.";echo
             exit
          fi        
       fi
   else
	     echo "Sentinel System Driver package 7.5.4 is not installed!!"
		 exit
	   fi
   else
    echo "Sentinel System Driver package 7.5.4 is not installed!!"
	exit
   fi
sudo chmod 775 /Library/Receipts/SafenetSentinelProduct.Info
fi

### Check whether Ultrapro SDK package is installed
    [ -d "$UPRO_PCKG_PATH" ]
    if [ $? -eq 0 ]
    then
      echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo
      ISDRIVER=1
    fi

### Check whether Ultrapro SPI package is installed
if [ $ISDRIVER = 0 ]
then
#    [ -d "$UPRO_SPI_PATH" ]
	[ -d /Applications/Sentinel/Sentinel\ Protection\ Server ]
    if [ $? -eq 0 ]
    then
      echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo
      ISDRIVER=1
    fi
fi

### Check whether Ultrapro Framework package is installed
if [ $ISDRIVER = 0 ]
then  
  [ -d "$UPRO_FRMWRK_PATH" ]
    if [ $? -eq 0 ]
    then
      echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo
      ISDRIVER=1
    fi
fi

### Check whether Ultrapro KM package is installed
if [ $ISDRIVER = 0 ]
then  
  [ -d "$UPRO_KM_PATH" ]
    if [ $? -eq 0 ]
    then
      echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo
      ISDRIVER=1
    fi
fi

### Check whether Sentinel Keys SDK is installed
if [ $ISDRIVER = 0 ]
then
    [ -d "$SDK_PCKG_PATH" ]
    if [ $? -eq 0 ]
    then
     echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo
     ISDRIVER=1
    fi
fi

### Check whether Sentinel Keys License Manager is installed
if [ $ISDRIVER = 0 ]
then
    [ -d "$LICMGR_PCKG_PATH" ]
    if [ $? -eq 0 ]
    then
      echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo
      ISDRIVER=1
    fi
fi

### Check whether Sentinel Keys Protection Installer is installed
if [ $ISDRIVER = 0 ]
then  
#  [ -d "$SKPI_PCKG_PATH" ]
  [ -d /Applications/Safenet\ Sentinel/Common\ Files/Sentinel\ Keys\ Server ]
    if [ $? -eq 0 ]
    then
      echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo
      ISDRIVER=1 
    fi
fi

### Checking whether SuperPro is installed
if [ $ISDRIVER = 0 ]
then  
 [ -d $SUPRO_PCKG_PATH ]
   if [ $? -eq 0 ]
   then
     echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo
     ISDRIVER=1
   fi
fi

### Double check SafenetSentinelProduct.Info
### Check if SHK SDK package installed
if [ $ISDRIVER = 0 ]
then    
    sudo chmod 777 /Library/Receipts/SafenetSentinelProduct.Info
   `grep SentinelKeysSDK /Library/Receipts/SafenetSentinelProduct.Info | cut -d = -f 1` > /dev/null 2>&1
   if [ $? -ne 0 ]
    then 
       echo "Cannot uninstall the Sentinel System Driver because some other package is using it.";echo
       ISDRIVER=1
    fi
fi

### Check if Sentinel System Driver Package installed
if [ $ISDRIVER = 0 ]
then    
#    [ -d "/Library/Receipts/SentinelSystemDriver.pkg" ]

   `grep SentinelSystemDriver /Library/Receipts/SafenetSentinelProduct.Info | cut -d = -f 1` > /dev/null 2>&1
   if [ $? -ne 0 ]
    then 
       echo "Cannot uninstall the Sentinel System Driver because some other package is using it.";echo
       ISDRIVER=1
    fi
fi

### Checking if SentinelKeysProtectionInstaller.pkg is installed
if [ $ISDRIVER = 0 ]
then
#   [ -d "/Library/Receipts/SentinelKeysProtectionInstaller.pkg" ]

   `grep SentinelKeysProtection /Library/Receipts/SafenetSentinelProduct.Info | cut -d = -f 1` > /dev/null 2>&1 
  if [ $? -ne 0 ]
   then
     echo "Cannot uninstall the Sentinel System Driver because some other package is using it.";echo 
     ISDRIVER=1
   fi
fi

### Checking if SentinelKeysLicensemanager.pkg is installed..
if [ $ISDRIVER = 0 ]
then
#   [ -d "/Library/Receipts/SentinelKeysLicenseManager.pkg" ]

   `grep SentinelKeysLicenseManager /Library/Receipts/SafenetSentinelProduct.Info | cut -d = -f 1` > /dev/null 2>&1 
  if [ $? -ne 0 ]
   then
     echo "Cannot uninstall the Sentinel System Driver because some other package is using it.";echo 
     ISDRIVER=1
   fi
fi

### Checking if SentinelSuperProSDK.pkg is installed..
if [ $ISDRIVER = 0 ]
then
#   [ -d "/Library/Receipts/SentinelSuperProSDK.pkg" ]

   `grep SentinelSuperProSDK /Library/Receipts/SafenetSentinelProduct.Info | cut -d = -f 1` > /dev/null 2>&1 
  if [ $? -ne 0 ]
   then
     echo "Cannot uninstall the Sentinel System Driver because some other package is using it.";echo 
     ISDRIVER=1
   fi
fi

if [ $ISDRIVER = 0 ]
then
# Unload the Sentinel System Driver
 sudo kextstat | grep Sentinel > /dev/null 2>&1
  if [ $? = 0 ]; then
  echo "Unload the Sentinel System Driver..."; echo
  touch /tmp/temp > /dev/null 2>&1
  ( sudo kextunload /Library/Extensions/Sentinel.kext 2>&1 | tee /tmp/temp > /dev/null )
  if [ `wc -c < /tmp/temp` = 0 ]; then
    echo "Sentinel System Driver unloaded successfully."; echo 
  else
    grep Failed /tmp/temp > /dev/null 2>&1
  if [ $? = 0 ]; then
    echo "Failed to unload the driver.";echo
    rm /tmp/temp
  else
    echo "Sentinel System Driver unloaded successfully."; echo   
  fi
 fi
  rm -rf /tmp/temp

 fi


### Remove Sentinel.kext
    [ -d /Library/Extensions/Sentinel.kext ]
    if [ $? = 0 ]; then
      sudo rm -rf /Library/Extensions/Sentinel.kext
      #sudo rm -rf /Library/Extensions/SNTLClassicNotSeizeDriver.kext
    fi

	[ -f /Library/LaunchDaemons/com.safenet.sentinel.kext.plist ]
    if [ $? = 0 ]; then
      sudo launchctl unload -w /Library/LaunchDaemons/com.safenet.sentinel.kext.plist
      sudo rm -f /Library/LaunchDaemons/com.safenet.sentinel.kext.plist
    fi
    
### Remote the pkg from db
    sudo pkgutil --forget com.apple.Safenet.SentinelSystemDriver > /dev/null 2>&1
	


  echo "Sentinel System Driver version 7.5.4 components have been successfully removed from the system."
  echo "Please restart the machine to complete uninstallation  . "; echo
fi




